Module | Facets
In: | lib/facets/sys.rb

# Facets System

This is a central "meta" controller for the Facets system. It can be used to dynmically gleen information about Facets. Or used to load a facet give the symbol of the actual method.

## Synopsis

     TODO

### Methods

extensions extensions_nice nice_only op_esc op_esc_path require

### Classes and Modules

Module Facets::Automatic

### Constants

OPERATORS | = | %w{ +@ -@ + - ** * / % ~ <=> << >> < > === == =~ <= >= | & ^ []= [] }
OPERATORS_REGEXP | = | Regexp.new( '(' << OPERATORS.collect{ |k| Regexp.escape(k) }.join('|') << ')' )

OPERATORS_ESCAPE

=

{ "+@" => "op_plus_self", "-@" => "op_minus_self", "+" => "op_plus", "-" => "op_minus", "**" => "op_pow", "*" => "op_mul", "/" => "op_div", "%" => "op_mod", "~" => "op_tilde", "<=>" => "op_cmp", "<<" => "op_lshift", ">>" => "op_rshift", "<" => "op_lt", ">" => "op_gt", "===" => "op_case_eq", "==" => "op_equal", "=~" => "op_apply", "<=" => "op_lt_eq", ">=" => "op_gt_eq", "|" => "op_or", "&" => "op_and", "^" => "op_xor", "[]=" => "op_store", "[]" => "op_fetch"

CLASS_ANCESTORS

=

{ 'array' => ['enumerable','kernel'], 'binding' => ['kernel'], 'class' => ['module','kernel'], 'comparable' => ['kernel'], 'continuation' => ['kernel'], 'date' => ['comparable','kernel'], 'dir' => ['enumerable','kernel'], 'enumerable' => ['kernel'], 'file' => ['io','enumerable','kernel'], 'fileutils' => ['kernel'], 'float' => ['precision','numeric','comparable','kernel'], 'hash' => ['enumerable','kernel'], 'integer' => ['precision','numeric','comparable','kernel'], 'kernel' => ['kernel'], 'logger' => ['kernel'], 'matchdata' => ['kernel'], 'module' => ['kernel'], 'nilclass' => ['kernel'], 'numeric' => ['comparable','kernel'], 'ostruct' => ['kernel'], 'pathname' => ['kernel'], 'proc' => ['kernel'], 'range' => ['enumerable','kernel'], 'regexp' => ['kernel'], 'string' => ['enumerable','comparable','kernel'], 'symbol' => ['kernel'], 'time' => ['comparable','kernel'], 'unboundmethod' => ['kernel'], }

NOAUTO

=

%w{ array/op_fetch.rb array/op_store.rb binding/self/of_caller.rb hash/op_fetch.rb hash/op_store.rb numeric/succ.rb numeric/pred.rb string/succ.rb string/unpack.rb module/attr.rb hash/each.rb module/methods.rb object/method.rb nilclass/op_fetch.rb nilclass/empty.rb nilclass/include.rb nilclass/size.rb nilclass/length.rb nilclass/method_missing.rb date/* fileutils/* ostruct/* logger/* gem/* }

METHDIR | = | "facet"

### External Aliases

require | -> | require_facetless

### Public Instance methods

extensions()

Returns a file list of all extensions.

extensions_nice()

Returns file list of all extensions minus the ones that should not be autoloaded.

nice_only( exts )

Removes the NOAUTO files from the given extensions list.

op_esc( str )
op_esc_path( name )

Subs terms for Ruby‘s operators and removes any trailing ? ! or =.

require( klass, fname )

[Validate]